package stx.libjava.tools.compiler.ecj;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.internal.compiler.classfmt.ClassFileReader;
import org.eclipse.jdt.internal.compiler.classfmt.ClassFormatException;
import org.eclipse.jdt.internal.compiler.env.IBinaryType;

/**
 * A registry for binary types. Eventually will do some caching in the future...
 * @author Jan Vrany
 *
 */
public class CompilerTypeRegistry {
	protected Map<String, IBinaryType> typeMap = new HashMap<String, IBinaryType>();
	
	public IBinaryType get(String name) {
		return typeMap.get(name);
	}
	
	public void put(String name, IBinaryType type) {
		typeMap.put(name,type);
	}
		
	public void put(String name, InputStream classfile) {
		try {
			put(name, ClassFileReader.read(classfile, (new String(name).replace('.', '/') + ".class")));
		} catch (ClassFormatException e) {
			throw new RuntimeException(e);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	public void put(String name, byte[] classfile) {
		put(name, new ByteArrayInputStream(classfile));
	}
	
	

}
